/*
   File: dcg.h
   Defines some global definitions

   CVS ID: "$Id: dcg.h,v 1.14 2005/02/24 14:59:34 marcs Exp $"
*/
#ifndef IncDcg
#define IncDcg

/*
   Define the 64 bit ints and constants
*/
#if defined(WIN32) && !defined(__MINGW32__)

/* WIN32 with Visual C++ */
typedef unsigned int u_int;
typedef __int64 int64;
typedef unsigned __int64 u_int64;
#define int64_const(x) (x##i64)
#define u_int64_const(x) (x##ui64)

#else

/* MINGW with gcc */
/* Unix with gcc */
#include <sys/types.h>
#if defined(__STRICT_ANSI__) || defined(__MINGW32__)
/* usually present in sys/types.h */
typedef unsigned int u_int;
#endif /* defined(__STRICT_ANSI__) || defined(__MINGW32__) */

typedef long long int int64;
typedef unsigned long long int u_int64;
#define int64_const(x) (x##LL)
#define u_int64_const(x) (x##ULL)

#endif /* defined(WIN32) && !defined(__MINGW32__) */

/* Introduce other types */
typedef double real;
typedef void *vptr;

#define int_nil 0
#define u_int_nil 0
#define int64_nil int64_const(0)
#define u_int64_nil u_int64_const(0)
#define real_nil 0.0
#define char_nil '\0'
#define vptr_nil ((vptr) NULL)

#define detach_int(old) 
#define detach_u_int(old)
#define detach_int64(old) 
#define detach_u_int64(old)
#define detach_real(old) 
#define detach_char(old) 
#define detach_vptr(old)

#define rdup_int(old)  (old)
#define rdup_u_int(old) (old)
#define rdup_int64(old)  (old)
#define rdup_u_int64(old) (old)
#define rdup_real(old)  (old)
#define rdup_char(old)  (old)
#define rdup_vptr(old) (old)

#define cmp_int(a,b)     (((a)<(b))?-1:((a)>(b))?1:0)
#define cmp_u_int(a,b)   (((a)<(b))?-1:((a)>(b))?1:0)
#define cmp_int64(a,b)   (((a)<(b))?-1:((a)>(b))?1:0)
#define cmp_u_int64(a,b) (((a)<(b))?-1:((a)>(b))?1:0)
#define cmp_real(a,b)    (((a)<(b))?-1:((a)>(b))?1:0)
#define cmp_char(a,b)    (((a)<(b))?-1:((a)>(b))?1:0)

#define equal_int(a,b)     ((a) == (b))
#define equal_u_int(a,b)   ((a) == (b))
#define equal_int64(a,b)   ((a) == (b))
#define equal_u_int64(a,b) ((a) == (b))
#define equal_real(a,b)    ((a) == (b))
#define equal_char(a,b)    ((a) == (b))
#define equal_vptr(a,b)    ((a) == (b))

#endif /* IncDcg */
