/*
   File: dcg_arith.h
   Defines some arithmetic support

   CVS ID: "$Id: dcg_arith.h,v 1.6 2005/02/24 14:59:35 marcs Exp $"
*/
#ifndef IncDcgArith
#define IncDcgArith

/* include math */
#include <math.h>

/* exclude min and max for WIN32 */
#ifndef WIN32
#define max(a,b) (((a)<(b))?(b):(a))
#define min(a,b) (((a)>(b))?(b):(a))
#endif

#define odd(a) ((a)&1)
#define even(a) (!((a)&1))
#define iabs(a) (((a)<0)?(-(a)):(a))
#define rabs(a) (((a)<0.0)?(-(a)):(a))

#define power10(x) pow(10.0, ((real) x))
#define ipower2(a) (1<<(a))
#define ipower10(a) (ipower(10,a));

int ilog2 (int nr);
int ilog10 (int nr);
int ipower (int nr, int exp);
int imod (int l, int r);
int irem (int l, int r);

#endif /* IncDcgArith */
