/*
   File: dcg_error.h
   Defines routines for diagnostic messages

   CVS ID: "$Id: dcg_error.h,v 1.6 2005/02/24 14:59:35 marcs Exp $"
*/
#ifndef IncDcgError
#define IncDcgError

/* Standard includes */
#include <stdio.h>

/* Local includes */
#include <dcg.h>

/* Exported variables */
extern int debug;
extern int verbose;
extern int full_verbose;

/* Exported logging functions */
void panic (char *format, ...);
void error (char *format, ...);
void wlog (char *format, ...);
void warning (char *format, ...);
void hint (char *format, ...);
void eprint (char *format, ...);

/* Other exported functions */
void init_error (FILE *f, char *tname, void (*onexit)());
void internal_error (char *routine);
void bad_tag (int tag, char *routine);
void panic_if_errors ();

#endif /* IncDcgError */
