/*
   File: dcg_string.h
   Defines string operations

   CVS ID: "$Id: dcg_string.h,v 1.8 2005/02/24 14:59:35 marcs Exp $"
*/
#ifndef IncDcgString
#define IncDcgString

/* include string for ops */
#include <string.h>

/* Local includes */
#include <dcg_alloc.h>

/* Introduce type string */
#define MAXSTRLEN 65536
typedef char *string;
#define string_nil ((string) NULL)
#define streq(s1,s2) (strcmp((s1),(s2)) == 0)
#define strlt(s1,s2) (strcmp((s1),(s2)) < 0)

/* Introduce attach/detach ops */
#define attach_string(t) dcg_attach(t)
#define att_string(t) (void) dcg_attach(t)
#define rdup_string(t) dcg_attach(t)
#define detach_string(t) dcg_detach(t)

/* Introduce support ops */
string new_string (char *t);
string alloc_string (char *t);
string concat_string (string t1, string t2);
string new_fmtd_string (char *format, ...);
string alloc_fmtd_string (char *format, ...);
int equal_string_nocase (string t1,string t2);
#define cmp_string(t1,t2) strcmp((t1),(t2))
#define equal_string(t1,t2) streq(t1,t2)

/* Introduce initialization */
void init_string_adm ();

#endif /* IncDcgString */
